<?php
/**
 * Драйвер для регистрации в системах статистики
 * 
 * @version  0.0.1
 */
class Reg {
    private $browser;
	private $parser;
    
	public function __construct() {
		$this->browser = new Curl();
		$this->browser->set_sleep(2,5);
		
		$this->parser = new Parser();
	}
	
    public function reg_li($params) {
        $post = "random=951782007&rules=agreed&type=site&nick={$params['domain']}&url=http%3A%2F%2F{$params['domain']}%2F&name={$params['domain']}&email={$params['email']}&password={$params['password']}&check={$params['password']}&keywords=&aliases=&language=ru&group=&private=on&subscribe=off&www=&confirmed=+%D0%B7%D0%B0%D1%80%D0%B5%D0%B3%D0%B8%D1%81%D1%82%D1%80%D0%B8%D1%80%D0%BE%D0%B2%D0%B0%D1%82%D1%8C+%3E%3E+";
    	$html = $this->browser->get_page('http://www.liveinternet.ru/add', $post);
    	if ( strpos($html, 'успешно зарегистрирован')!==false ){
    		return '<!--LiveInternet counter--><script type="text/javascript"><!--
document.write("<a href=\'//www.liveinternet.ru/click\' "+
"target=_blank><img src=\'//counter.yadro.ru/hit?t26.18;r"+
escape(document.referrer)+((typeof(screen)=="undefined")?"":
";s"+screen.width+"*"+screen.height+"*"+(screen.colorDepth?
screen.colorDepth:screen.pixelDepth))+";u"+escape(document.URL)+
";"+Math.random()+
"\' alt=\'\' title=\'LiveInternet: показано число посетителей за"+
" сегодня\' "+
"border=\'0\' width=\'0\' height=\'0\'><\/a>")
//--></script><!--/LiveInternet-->';
        }
        
        return false;
    }
    
    public function hide_values_li($params) {
        $html = $this->browser->get_page('http://www.liveinternet.ru/stat/', "url={$params['domain']}&password={$params['password']}", true, true);
        $rnd = $this->parser->parse_string($html, '|name=rnd value=([\d,]+)>|');
        
        $url = "http://www.liveinternet.ru/stat/{$params['domain']}/edit.html";
        $post ="report=edit.html&rnd={$rnd}&www=&aliases=&name={$params['domain']}&email={$params['email']}&newpass=&check=&newgpass=&gcheck=&keywords=&queries=&private=on&language=ru&group=&hide_values=on&ok=%D0%B2%D0%BD%D0%B5%D1%81%D1%82%D0%B8+%D0%B8%D0%B7%D0%BC%D0%B5%D0%BD%D0%B5%D0%BD%D0%B8%D1%8F&report=edit.html";
        $html = $this->browser->get_page($url, $post);
        
        if ( strpos($html, 'описание изменено')!==false || strpos($html, 'описание не изменилось')!==false ){
			return true;
		}
        
		return false;
	}
	
	public function counter_li() {
		$counter = '<!--LiveInternet counter--><script type="text/javascript"><!--
document.write("<a href=\'//www.liveinternet.ru/click\' "+
"target=_blank><img src=\'//counter.yadro.ru/hit?t26.18;r"+
escape(document.referrer)+((typeof(screen)=="undefined")?"":
";s"+screen.width+"*"+screen.height+"*"+(screen.colorDepth?
screen.colorDepth:screen.pixelDepth))+";u"+escape(document.URL)+
";"+Math.random()+
"\' alt=\'\' title=\'LiveInternet: показано число посетителей за"+
" сегодня\' "+
"border=\'0\' width=\'0\' height=\'0\'><\/a>")
//--></script><!--/LiveInternet-->';

		return $counter;
	}
	
	public function reg_yam($params) {
		global $settings;
		$token = $settings->yam_token;
		if ( !$token ) return false;
		
		$params = array(
			'name' => $params['domain'],
			'site' => $params['domain']
		);
		$params = json_encode($params);
		
		$opts = array(
			'http' => array(
				'method' => "POST",
				'header' => "Authorization: OAuth " . $token . "\r\n" .
							"Accept: application/x-yametrika+json" . "\r\n" .
							"Content-Type: application/x-yametrika+json" . "\r\n" .
							"Content-length: " . strlen($params) . "\r\n",
				'content' => $params
			)
		);
		$context = stream_context_create($opts);
		$result = file_get_contents("http://api-metrika.yandex.ru/counters", null, $context);
		
		return json_decode($result);
	}
	
	public function counter_yam($counter_id) {
		global $settings;
		$token = $settings->yam_token;
		if ( !$token ) return false;
		
		$counters = file_get_contents("http://api-metrika.yandex.ru/counter/{$counter_id}.json?oauth_token={$token}");
		if ( !$counters ) return false;
		
		$counters = json_decode($counters);
		
		return $counters->counter->code;
	}
	
	public function counter_ga($ga_id) {
		global $settings;
		$token = $settings->ga_token;
		if ( !$token ) return $stat;
		
		$client = new Google_Client();
		 
		$client->setClientId( $settings->ga_id );
		$client->setClientSecret( $settings->ga_secret );
		$client->setRedirectUri( 'http://' . $settings->host . '/ajax/ga.php' );
		$client->setDeveloperKey( $settings->ga_api_key );
		$client->setScopes( array('https://www.googleapis.com/auth/analytics.readonly', 'https://www.googleapis.com/auth/analytics') );
		$client->setAccessType('offline');
		$client->setApprovalPrompt('force');
		
		$oauth2 = new Google_Service_Oauth2($client);
	
		$client->setAccessToken( $settings->ga_token );
		
		$expired = $client->isAccessTokenExpired();
		if ( $expired ) {
			$client->refreshToken( $settings->ga_refresh_token );
			$settings->save_option('ga_token', $client->getAccessToken());
		}
		$analytics = new Google_Service_Analytics($client);
		
		$web_properties = $analytics->management_accountSummaries->listManagementAccountSummaries();
		
		foreach($web_properties['items'] as $web){
			foreach($web['webProperties'] as $pro){
				$ids = $pro['id'];
				foreach($pro['profiles'] as $p)
					if($p['id'] == $ga_id) break 2;
			}
		}
		if(!$ids) return false;
		
		$counter = "<script>
  (function(i,s,o,g,r,a,m){i['GoogleAnalyticsObject']=r;i[r]=i[r]||function(){
  (i[r].q=i[r].q||[]).push(arguments)},i[r].l=1*new Date();a=s.createElement(o),
  m=s.getElementsByTagName(o)[0];a.async=1;a.src=g;m.parentNode.insertBefore(a,m)
  })(window,document,'script','//www.google-analytics.com/analytics.js','ga');

  ga('create', '{$ids}', 'auto');
  ga('send', 'pageview');
</script>";

		return $counter;
	}
    
}